VPATH+=$(srcdir)
PATH+=:$(msvc)/VC/bin:$(msvc)/Common7/IDE:$(mssdk)/bin

MSCPPFLAGS+='-I$(msvc)/VC/include'
MSCPPFLAGS+='-I$(msvc)/VC/include'
MSCOMPILE+=$(CFLAGS)
MSCOMPILE+=$(MSCFLAGS)
MSCOMPILE+=$(CPPFLAGS)
MSCOMPILE+=$(MSCPPFLAGS)
MSCOMPILE.c=$(MSCL) $(MSCOMPILE) -c
MSCOMPILE_OUTPUT_OPTION=-Fo$(shell cygpath -w $@)

MSLDFLAGS+='-libpath:$(mssdk)/lib'
MSLDFLAGS+='-libpath:$(msvc)/VC/lib'
#MSLDLIBS+=uxtheme.lib
#MSLDLIBS+=comctl32.lib
#MSLDLIBS+=user32.lib
LDLIBS+=$(call ldlib,uxtheme)
LDLIBS+=$(call ldlib,comctl32)
LDLIBS+=$(call ldlib,user32)
MSLINK+=$(LDFLAGS)
MSLINK+=$(MSLDFLAGS)
MSLINK+=$(LOADLIBES)
MSLINK+=$(MSLOADLIBES)
MSLINK+=$(LDLIBS)
MSLINK+=$(MSLDLIBS)
MSLINK.c=$(MSCOMPILE) -link $(MSLINK)
MSLINK_OUTPUT_OPTION=-Fe$(shell cygpath -w $@)

MSCPPFLAGS+=-D_USING_V110_SDK71_
MSCPPFLAGS+='-I$(mssdk)/include'
MSCPPFLAGS+='-I$(msvc)/VC/include'
CPPFLAGS+='-I$(wasdk)'
CPPFLAGS+=-I$(includedir)

# the ms c compiler:
MSCL:=cl.exe -nologo
# the ms librarian:
MSLIB:=lib.exe -nologo
# the ms resource compiler:
MSRC:=rc.exe -nologo -n $(MSCPPFLAGS)

extexe:=.exe
extso:=.dll
ifeq (ms,$(tools)) ########################################################## [
exto:=.obj
exta:=.lib
extsoa:=.lib
extres:=.res
#the following needs to be without colon:
ldlib=$(1).lib
# link a program from an object:
$(bindir)/%: %$(exto)
	mkdir -p $(@D)
	$(MSCL) $^ $(MSLINK_OUTPUT_OPTION) -link $(MSLINK)
%: %$(exto)
	$(MSCL) $^ $(MSLINK_OUTPUT_OPTION) -link $(MSLINK)
# link a shared object from an object:
$(sodir)/%$(extso): %$(exto)
	mkdir -p $(@D)
	$(MSCL) $^ $(MSLINK_OUTPUT_OPTION) -LD -link $(MSLINK)
%$(extso): %$(exto)
	$(MSCL) $^ $(MSLINK_OUTPUT_OPTION) -LD -link $(MSLINK)
# place some file into a library:
(%): %
	if test -e $@; then $(MSLIB) -out:$@ $@ $<; else $(MSLIB) -wx -out:$@ $<; fi
#(%$(exto)): %.c
#	@echo $< -> $@
#	if test -e $@; then $(MSLIB) -out:$@ $@ $<; else $(MSLIB) -wx -out:$@ $<; fi
# compile an object from a c source file:
%$(exto): %.c
	$(MSCOMPILE.c) $(MSCOMPILE_OUTPUT_OPTION) $<
# create an import library from a definition file:
.PRECIOUS: %$(extsoa)
%$(extdlla): %.def
	$(MSLIB) -machine:x86 -def:$< -out:$@
else ###################################################################### ] [
exto:=.o
exta:=.a
extsoa:=.dll.a
extres:=.o
#the following needs to be without colon:
ldlib=-l$(1)
CC:=gcc
CFLAGS+=-Wall
CFLAGS+=-Werror
#LDLIBS+=-luxtheme
#LDLIBS+=-lcomctl32
# we use the rules provided by Make. we just have to add some rules w.r.t.
# shared objects.
# link a program from an object:
$(bindir)/%: %$(exto)
	mkdir -p $(@D)
#  recipe to execute (built-in):
	$(LINK.o) $^ $(LOADLIBES) $(LDLIBS) -o $@
# link a shared object from an object:
%$(extso): %$(exto)
	$(CC) $(CFLAGS) $(CPPFLAGS) $^ $(LDFLAGS) $(LDLIBS) -o $@
$(sodir)/%$(extso): %$(exto)
	mkdir -p $(@D)
	$(CC) $(CFLAGS) $(CPPFLAGS) $^ $(LDFLAGS) $(LDLIBS) -o $@
# create an import library from a definition file:
.PRECIOUS: %$(extsoa)
%$(extsoa): %.def
	dlltool -d $< --output-delaylib $@
endif ####################################################################### ]
