/*
 * pib.c
 *
 * Copyright (C) 2020 Peter Belkner <pbelkner@users.sf.net>
 * Nanos gigantum humeris insidentes #TeamWhite
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.0 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301  USA
 */
#include <pib.h>

HWND pib_hwnd_parent(void)
{
  /*
   * making the playlist editor the parent of our modless dialog let
   * appear our modless dialog always on top of Winamp. that's exactly
   * what we want to have.
   */
  HWND hwnd_main=plugin_hwnd_main();
  HWND hwnd_pe=(HWND)SendMessageW(hwnd_main,WM_WA_IPC,IPC_GETWND_PE,
      IPC_GETWND);

//DWRITELN("##########################################################");
//DVWRITELN("%p",GetParent(hwnd_pe));
//DWRITELN("##########################################################");
  return GetParent(hwnd_pe)?hwnd_pe:hwnd_main;
}
