/*
 * pib_ipc.h
 *
 * Copyright (C) 2020 Peter Belkner <pbelkner@users.sf.net>
 * Nanos gigantum humeris insidentes #TeamWhite
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.0 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301  USA
 */
#ifndef __PIB_IPC_H__ // [
#define __PIB_IPC_H__
#include <winamp/wa_ipc.h>

///////////////////////////////////////////////////////////////////////////////
#if ! defined (GPPHDR_VER_U) // [
#define GPPHDR_VER_U	          0x11
#endif // ]

#if ! defined(WINAMP_PLAY) // [
#define WINAMP_PLAY             40045
#endif // ]
#if ! defined(WINAMP_STOP) // [
#define WINAMP_STOP             40047
#endif // ]
#if ! defined(WINAMP_VISTOGGLE) // [
#define WINAMP_VISTOGGLE        40192
#endif // ]

#if ! defined (IPC_GETNEXTLISTPOS) // [
#define IPC_GETNEXTLISTPOS      136
#endif // ]
#if ! defined (IPC_CB_GETTOOLTIPW) // [
#define IPC_CB_GETTOOLTIPW      1602
#endif // ]
#if ! defined (IPC_GET_D3DX9) // [
#define IPC_GET_D3DX9           3044
#endif // ]
#if ! defined (IPC_GETINIDIRECTORYW) // [
#define IPC_GETINIDIRECTORYW    1335
#endif // ]
#if ! defined (IPC_GETPLUGINDIRECTORYW) // [
#define IPC_GETPLUGINDIRECTORYW 1336
#endif // ]
#if ! defined (IPC_STOPPLAYING) // [
#define IPC_STOPPLAYING         3043
#endif // ]

#define WM_PIB_IPC              WM_WA_IPC+100
/* SendMessage(hwnd_winamp,WM_PIB_IPC,PIB_CLOSE,0); */
#define PIB_CLOSE               100
/* SendMessage(hwnd_winamp,WM_PIB_IPC,PIB_REFRESH,0); */
#define PIB_REFRESH             101
/* SendMessage(hwnd_winamp,WM_PIB_IPC,YAS_INIT,0); */
#define YAS_INIT                200

#endif // ]
